#!/usr/bin/perl -w


$infile = $ARGV[0];
$outfile = "brefspec.hfa.txt";
$outbible = "hfa.bib";

open (IN, $infile);
open (OUT, ">$outbible");
open (SPEC, ">$outfile");

$book = 0;
$chapter = 0;
$verse = 0;

while ( $line = <IN> )
{
	if ( $line =~ /BibleBook/ )
	{
		$book = $line;
		$book =~ s/^.*ordernumber="//;
		$book =~ s/".*$//;
		chomp $book;
		next;
	}
	if ( $line =~ /Chapter/ )
	{
		$chapter = $line;
		$chapter =~ s/^.*number="//;
		$chapter =~ s/".*$//;
		chomp $chapter;
		next;
	}
	if ( $line =~ /Verse/ )
	{
		my $out = $line;
		$out =~ s/^<Verse[^>]*>//;
		$out =~ s/<\/Verse>//;
		$out =~ s/<[^>]*\/>//g;
		$out =~ s/<[^>]*>[^<]*<\/[^>]*>//g;
		$out =~ s//ss/g;
		$out =~ s//Ae/g;
	        $out =~ s//Oe/g;
		$out =~ s//Ue/g;
	        $out =~ s//ae/g;
		$out =~ s//oe/g;
	        $out =~ s//ue/g;
		$out =~ s//"/g;
		$out =~ s//"/g;
		print OUT $out;
		$verse = $line;
		$verse =~ s/^.*verse="//;
		$verse =~ s/".*$//;
		chomp $verse;
		print SPEC $book.":".$chapter.":".$verse."\n";
		next;
	}
}

