/***************************************************************************
                          appmain.cpp  -  description
                             -------------------
    begin                : Don Aug 28 2003
    copyright            : (C) 2003 by David Weisgerber
    email                : tnt@md.2y.net
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "appmain.h"
#include "new.h"

appmain::appmain( GPDRAWSURFACE m_surface )
{
  gpDraw = m_surface;          

  menucreated = false;
  
  GpKeyInit();
  GpFatInit();
  readdef();

  //GpTextOut( NULL, &gpDraw, 10, 30, bible->getbook(), 0x00 );
  /*gp_str_func.sprintf( test, "Kapitel: %d, Verse: %d", bible->getchapter( 1 ),
                                                       bible->getverses( 3, 16 ) );*/
  GpFileOpen( FILE2, OPEN_R, &bibh );
  bible->setpos( 0, 1, 1 );
  in_menu = false;
  displaytext();
  createmenu(); 
}
appmain::~appmain(){
}
/** No descriptions */
void appmain::clearscreen()
{
  GpRectFill( NULL, &gpDraw, 0, 0, 320, 240, 0xFF );
}
/** No descriptions */
void appmain::exec()
{
  while(1)
  {
    getkeyevent();
  }
    
}
/** No descriptions */
void appmain::readdef()
{
  char c;
  char *title=0, *testament, *book, *recin, out[64];
  short i, vx=30, vers, chapter, length;
  int offset;
  unsigned long int size;
  F_HANDLE fh;
  
  recin = (char*)gp_mem_func.malloc( sizeof(char) * 256 );
  bible = new bbook();
  
  GpFileOpen( FILE, OPEN_R, &fh );
  //GpTextOut( NULL, &gpDraw, 40, vx, "Test", 0x00);
  //vx += 20;
  
  while (!GpFileRead( fh, (char*)&c, 1, &size ))
  {
    switch(c)
    {
      case 0x01: //Title of the bible translation
        if (!title)
        {
          GpFileRead( fh, (short*)&i, 2, &size );
          title = (char*)gp_mem_func.malloc( sizeof(char) * i );
          GpFileRead( fh, (char*)recin, i, &size );
          gp_str_func.strncpy( title, recin, i ); // Anyway everything on the GP32 memalloc
                                                  // seems a little bit sloppy written so
                                                  // I use this to have a *clean* copy
          bible->settitle( title );
          gp_str_func.sprintf( out, "Translation: %s", title );
          GpTextOut( NULL, &gpDraw, 10, 200, out, 0x00);
          //vx += 10;
        }
        break;                 
      case 0x02: //Change of OT / NT
        GpFileRead( fh, (short*)&i, 2, &size );
        testament = (char*)gp_mem_func.malloc( sizeof(char) * i );
        GpFileRead( fh, (short*)&vers, 2, &size );
        GpFileRead( fh, (char*)recin, i, &size );
        gp_str_func.strncpy( testament, recin, i );
        bible->i_settestament( testament );
        //GpTextOut( NULL, &gpDraw, 10, vx, testament, 0x00);
        //vx += 10;
        break;
      case 0x03: // Change of Book
        GpFileRead( fh, (short*)&i, 2, &size );
        book = (char*)gp_mem_func.malloc( sizeof(char) * i );
        GpFileRead( fh, (short*)&vers, 2, &size );
        GpFileRead( fh, (char*)recin, i, &size );
        gp_str_func.strncpy( book, recin, i );
        bible->i_setbook( vers, book );
        //GpTextOut( NULL, &gpDraw, 10, vx, book, 0x00);
        //vx += 10;
        break;
      case 0x04: // Entry
        GpFileRead( fh, (short*)&chapter, 2, &size );
        GpFileRead( fh, (short*)&vers, 2, &size );
        GpFileRead( fh, (int*)&offset, 4, &size );
        GpFileRead( fh, (short*)&length, 2, &size );
        bible->addentry( chapter, vers, offset, length );
        break;
      default: // This shouldn't happen
        GpTextOut( NULL, &gpDraw, 10, vx, "Fehler!", 0x00 );
        vx += 10;
        break;
    }
  }
  gp_mem_func.free( recin );
  GpFileClose( fh );          
}
/** No descriptions */
int appmain::textbreak( char *text, int length )
{
  int i = LINELENGTH;
  int z = 0;
  int retval = 1;
  
  while ( i < length )
  {
    z = i;
    text += sizeof(char) * i;
    while ( z > 0 )
    {
      if ( *text == ' ' )
      {
        *text = '\n';
        retval++;
        break;
      }
      z--;
      --text;
    }
    text -= sizeof(char) * z;
    i = z + 1 + LINELENGTH;
  }
  return retval;  
}
/** No descriptions */
void appmain::displaytext( )
{
  int offset, length;
  char *text, *recin;
  char head[40];

  in_menu = false;
  
  offset = bible->offset();
  length = bible->length();

  text = (char*)gp_mem_func.malloc( sizeof(char) * length );
  recin = (char*)gp_mem_func.malloc( sizeof(char) * length );
  gp_str_func.sprintf( head, "%s %d, %d", bible->book(), bible->chapter(), bible->vers() );
  
  GpFileSeek( bibh, FROM_BEGIN, offset, NULL );
  GpFileRead( bibh, (char*)recin, length, NULL );
  gp_str_func.strncpy( text, recin, length );
  textbreak( text, length );
  clearscreen();
  GpTextOut( NULL, &gpDraw, 15, 30, text, 0x00 );
  GpTextNOut( NULL, &gpDraw, 15, 10, head, 0, length, 0x00 );
  gp_mem_func.free( text );
  gp_mem_func.free( recin );      
}

/** No descriptions */
void appmain::next()
{
  bible->next();
  displaytext();
}
/** No descriptions */
void appmain::prev()
{
  bible->prev();
  displaytext();
}
/** No descriptions */
void appmain::getkeyevent()
{
  int key;

  key = GpKeyGet();
  if ( !GpKeyChanged() )
    return;

  switch (key)
  {
    case GPC_VK_FL:
      prev();
      break;
    case GPC_VK_FR:
      next();
      break;
    case GPC_VK_SELECT:
      if ( !in_menu )
        displaymenu();
      else
        displaytext();
      break;
    case GPC_VK_UP:
      if ( in_menu )
        menuprev();
      break;
    case GPC_VK_DOWN:
      if ( in_menu )
        menunext();
      break;
    case GPC_VK_FA:
      if ( in_menu )
        menufnext();
      break;
    case GPC_VK_FB:
      if ( in_menu )
        menufprev();
      break;
    case GPC_VK_START:
      if ( in_menu )
        menuok();
      break;
    default:
      break;
  }    
}

    /** No descriptions */
void appmain::displaymenu()
{
  in_menu = true;
  clearscreen();

  GpTextOut ( NULL, &gpDraw, 10, 10, "Title:", 0x00 );
  if (!trc->active()) trc->paint( &gpDraw );

  GpTextOut ( NULL, &gpDraw, 10, 40, "Testament:", 0x00 );
  if (!tesc->active()) tesc->paint( &gpDraw );
        
  GpTextOut ( NULL, &gpDraw, 10, 70, "Book:", 0x00 );
  if (!bookc->active()) bookc->paint( &gpDraw );

  GpTextOut ( NULL, &gpDraw, 10, 100, "Chapter:", 0x00 );
  if (!chac->active()) chac->paint( &gpDraw );

  GpTextOut ( NULL, &gpDraw, 10, 130, "Vers:", 0x00 );
  if (!verc->active()) verc->paint( &gpDraw );    

  if (trc->active()) trc->paint( &gpDraw );
  if (tesc->active()) tesc->paint( &gpDraw );
  if (bookc->active()) bookc->paint( &gpDraw );
  if (chac->active()) chac->paint( &gpDraw );
  if (verc->active()) verc->paint( &gpDraw );

  GpTextOut ( NULL, &gpDraw, 10, 160, "Start: OK\nSelect: Cancel\nA: Next\nB: Previous", 0x00 );    
}

/** No descriptions */
void appmain::createmenu()
{
  int i = 0;
  int t = 0;
  char *out;
  
  trc = new combo( 120, 10 );
  trc->add( bible->gettitle() );
  trc->set( 0 );

  tesc = new combo( 120, 40 );
  i = 0;
  while ( i < bible->gettestamentnum() )
  {
    tesc->add( bible->gettestamentname( i ) );
    i++;
  }
  tesc->set( 0 );
  tesc->setselected( true );
  
  bookc = new combo( 120, 70 );
  i = 0;
  while ( i < bible->getbooknum() )
  {
    if ( bible->getbooktestamentnum( i ) == tesc->get() )
      bookc->add( bible->getbookname( i ) );
    i++;
  }
  bookc->set( 0 );

  chac = new combo( 120, 100 );
  i = 0;
  t = bible->getchapter( bible->getcurrent() );
  while ( i < t )
  {
    out = (char*)gp_mem_func.malloc( sizeof(char) * 5 );
    gp_str_func.sprintf( out, "%d", i+1 );
    chac->add( out );
    i++;
  }
  chac->set( bible->chapter() -1 );

  verc = new combo( 120, 130 );
  i = 0;
  t = bible->getverses( bible->getcurrent(), bible->getchapter( bible->getcurrent() ) );
  while ( i < t )
  {
    out = (char*)gp_mem_func.malloc( sizeof(char) * 5 );
    gp_str_func.sprintf( out, "%d", i+1 );
    verc->add( out );
    i++;
  }
  verc->set( bible->vers() -1 );                                                                     
}
/** No descriptions */
void appmain::menuprev()
{
  if (trc->active())
  {
    trc->prev();
    trc->paint( &gpDraw );
  }
  if (tesc->active())
  {
    tesc->prev();
    tesc->paint( &gpDraw );
  }
  if (bookc->active())
  {
    bookc->prev();
    bookc->paint( &gpDraw );
  }
  if (chac->active())
  {
    chac->prev();
    chac->paint( &gpDraw );
  }
  if (verc->active())
  {
    verc->prev();
    verc->paint( &gpDraw );
  }  
}
/** No descriptions */
void appmain::menunext()
{
  if (trc->active())
  {
    trc->next();
    trc->paint( &gpDraw );
  }
  if (tesc->active())
  {
    tesc->next();
    tesc->paint( &gpDraw );
  }
  if (bookc->active())
  {
    bookc->next();
    bookc->paint( &gpDraw );
  }
  if (chac->active())
  {
    chac->next();
    chac->paint( &gpDraw );
  }
  if (verc->active())
  {
    verc->next();
    verc->paint( &gpDraw );
  }
}
/** No descriptions */
void appmain::menufnext()
{
  int i, t;
  char *out;
  int testamentstart = bible->gettstart( tesc->get() );
  
  if ( tesc->active() )
  {
    tesc->setselected( false );

    bookc->clear();

    i = 0;
    while ( i < bible->getbooknum() )
    {
      if ( bible->getbooktestamentnum( i ) == tesc->get() )
        bookc->add( bible->getbookname( i ) );
      i++;
    }
    bookc->set( 0 );  

    chac->clearfree();
    i = 0;
    t = bible->getchapter( bookc->get() + testamentstart );
    while ( i < t )
    {
      out = (char*)gp_mem_func.malloc( sizeof(char) * 5 );
      gp_str_func.sprintf( out, "%d", i+1 );
      chac->add( out );
      i++;
    }
    chac->set( 0 );

    verc->clearfree();
    i = 0;
    t = bible->getverses( bookc->get() + testamentstart, bible->getchapter( bookc->get() + testamentstart ) );
    while ( i < t )
    {
      out = (char*)gp_mem_func.malloc( sizeof(char) * 5 );
      gp_str_func.sprintf( out, "%d", i+1 );
      verc->add( out );
      i++;
    }
    verc->set( 0 );

    bookc->setselected( true );

    tesc->paint( &gpDraw );
    chac->paint( &gpDraw );
    verc->paint( &gpDraw );
    bookc->paint( &gpDraw );
    return;
  }
  
  if (bookc->active())
  {
    bookc->setselected( false );

    chac->clearfree();
    i = 0;
    t = bible->getchapter( bookc->get() + testamentstart );
    while ( i < t )
    {
      out = (char*)gp_mem_func.malloc( sizeof(char) * 5 );
      gp_str_func.sprintf( out, "%d", i+1 );
      chac->add( out );
      i++;
    }
    chac->set( 0 );

    verc->clearfree();
    i = 0;
    t = bible->getverses( bookc->get() + testamentstart, bible->getchapter( bookc->get() + testamentstart ) );
    while ( i < t )
    {
      out = (char*)gp_mem_func.malloc( sizeof(char) * 5 );
      gp_str_func.sprintf( out, "%d", i+1 );
      verc->add( out );
      i++;
    }
    verc->set( 0 );

    chac->setselected( true );

    tesc->paint( &gpDraw );
    bookc->paint( &gpDraw );
    verc->paint( &gpDraw );
    chac->paint( &gpDraw );
    return;
  }

  if ( chac->active() )
  {
    chac->setselected( false );
  
    verc->clearfree();
    i = 0;
    t = bible->getverses( bookc->get()+ testamentstart, chac->get() + 1 );
    while ( i < t )
    {
      out = (char*)gp_mem_func.malloc( sizeof(char) * 5 );
      gp_str_func.sprintf( out, "%d", i+1 );
      verc->add( out );
      i++;
    }
    verc->set( 0 );

    verc->setselected( true );

    tesc->paint( &gpDraw );
    bookc->paint( &gpDraw );
    chac->paint( &gpDraw );
    verc->paint( &gpDraw );
    return;
  }

  if ( verc->active() )
  {
    verc->setselected( false );
    bookc->setselected( true );

    bible->setpos( bookc->get() + testamentstart, chac->get() + 1, verc->get() + 1 );
    in_menu = false;
    displaytext();
    return;
  }      
}
/** No descriptions */
void appmain::menufprev()
{
  if ( tesc->active() )
  {
    tesc->setselected( false );
    verc->setselected( true );
    tesc->paint( &gpDraw );
    bookc->paint( &gpDraw );
    chac->paint( &gpDraw );
    verc->paint( &gpDraw );
  }    
  if ( bookc->active() )
  {
    bookc->setselected( false );
    tesc->setselected( true );
    bookc->paint( &gpDraw );
    chac->paint( &gpDraw );
    verc->paint( &gpDraw );
    tesc->paint( &gpDraw );
    return;
  }
  if ( chac->active() )
  {
    chac->setselected( false );
    bookc->setselected( true );
    tesc->paint( &gpDraw );
    verc->paint( &gpDraw );
    chac->paint( &gpDraw );
    bookc->paint( &gpDraw );
    return; 
  }
  if ( verc->active() )
  {
    verc->setselected( false );
    chac->setselected( true );
    tesc->paint( &gpDraw );
    bookc->paint( &gpDraw );
    verc->paint( &gpDraw );
    chac->paint( &gpDraw );
    return;
  }  
}
/** No descriptions */
void appmain::menuok()
{
  int testamentstart = bible->gettstart( tesc->get() );
  bible->setpos( bookc->get() + testamentstart, chac->get() + 1, verc->get() + 1 );
  in_menu = false;
  displaytext();  
}
